-- frmSettings.lua
-- written by Habna

--v IMPORT SECTION v--

--^ IMPORT SECTION ^--

--v GLOBAL VARIABLE SECTION v--
InitXPos, InitYPos = 30,30; --> ** Initial X & Y position of the first Item in the HugeBag **
StartVisible = false; --> ** Initial value to determine if HugeBag start visible or not **
WinWidth, WinHeight = 450,289; --> ** HugeBag initial size **
WinLocX, WinLocY = 949, 450; --> ** HugeBag initial location **
winRate = 30;
Widget = true;
HideWEsc = false; --> ** Initial value to determine if HugeBag hide when 'esc' key is press **
windowOpen = false;
screenWidth, screenHeight = Turbine.UI.Display.GetSize()
write = Turbine.Shell.WriteLine;
--^ GLOBAL VARIABLE SECTION ^--

--v FUNCTIONS/METHODS SECTION v--
-- **v Load settings v**
function LoadSettings()
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettings" );
	
	-- **v no setting found, so save it v**
	if settings == nil then
		SaveSettings();
	end
	-- **^
	-- **v Load Settings v**
	WinLocX = settings.X;
	WinLocY = settings.Y;
	HideWEsc = settings.HideWEsc;
	StartVisible = settings.StartVisible;
	-- **^
	-- **v Check version so settings can be updated (if a user used an old version before the last release)
	if ( settings.Version ~= Version ) then
		local Updatedsettings = {};

		Updatedsettings.X = WinLocX;
		Updatedsettings.Y = WinLocY;

		if settings.HideWEsc == nil then
			Updatedsettings.HideWEsc = false;
		else
			Updatedsettings.HideWEsc = HideWEsc;
		end

		if settings.StartVisible == nil then
			Updatedsettings.StartVisible = false;
		else
			Updatedsettings.StartVisible = StartVisible;
		end

		Updatedsettings.Version = Version;
		Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", Updatedsettings );
	end
	-- **^
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.StartVisible = StartVisible;
	settings.HideWEsc = HideWEsc;
	settings.X = WinLocX;
	settings.Y = WinLocY;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", settings );

	Widgetsettings = {};
	Widgetsettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Widgetsettings );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	frmMain:SetPosition( 949, 450 );
	WinLocX, WinLocY = frmMain:GetPosition();
	StartVisible = false;
	HideWEsc = false;
	Widget = Widget;
	if ( windowOpen ) and ( not StartVisible ) then
		frmMain:SetVisible( true ); -- **v Hide HugeBag if ESC key is press v**
		slideCtr:SetWantsUpdates(true);
	end
	SaveSettings()
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--